Merge branch 'master' of vampire:~mdw/etc/profile
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43 else
44 echon="echo"
45 echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56 else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74 done
75 echo " all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87 "
88 for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115 done
116 echo " all done."
117
118 ###--------------------------------------------------------------------------
119 ### Install global configuration.
120
121 echo -n "Installing dotfile configuration:"
122 if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124 else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127 fi
128
129 ## Symlink the various dotfiles into place
130 dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el ercrc.el
133 vimrc mg zile
134 ditz-config
135 mailrc signature
136 cgrc tigrc
137 gdbinit
138 guile
139 rcrc
140 toprc
141 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
142 aspell.conf
143 lisp-init.lisp:.cmucl-init.lisp
144 lisp-init.lisp:.sbclrc
145 lisp-init.lisp:.clisprc.lisp
146 lisp-init.lisp:.eclrc
147 swank.lisp
148 dircolors colordiffrc screenrc cvsrc indent.pro"
149 [ "$xstuff" ] && dotfiles="$dotfiles
150 xinitrc xsession Xdefaults vncrc vncsession
151 fonts.conf
152 stalonetrayrc
153 putty-defaults:.putty/sessions/Default%20Settings
154 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
155 e-keybindings.cfg:.enlightenment/keybindings.cfg
156 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
157 e16-bindings:.e16/bindings.cfg"
158 echo "Installing dotfiles..."
159 for d in $dotfiles; do
160 target=.$d
161 case $d in
162 *:*) target=${d#*:} d=${d%%:*};;
163 esac
164 ft=$HOME$sub/$target
165 dir=${ft%/*}
166 mkdir -p $dir
167 ln -s $here/dot/$d $ft.new
168 mv $ft.new $ft
169 echo " $target"
170 done
171 echo " all done."
172
173 ## Substitute things which need substituting.
174 dotfilessubst="
175 gitconfig
176 pulse-default.pa.in:.pulse/default.pa"
177 echo "Installing dotfiles with substitutions..."
178 for d in $dotfilessubst; do
179 case $d in
180 *:*) target=${d#*:} d=${d%%:*};;
181 *) target=.$d d=$d.in;;
182 esac
183 ft=$HOME$sub/$target
184 dir=${ft%/*}
185 mkdir -p $dir
186 sed "
187 1i\
188 ### generated by $here/setup; do not edit!\
189
190 /@home@/ s\a\a$HOME\ag
191 /@releasekey@/ s\a\a$(bin/mdw-conf release-key 481334C2)\ag
192 /@gitignore@/ s\a\a$(bin/mdw-conf gitignore $here/git/gitignore)\ag
193 " dot/$d >$ft.new
194 mv $ft.new $ft
195 echo " $target"
196 done
197 echo " all done."
198
199 ## Symlink backgrounds.
200 backgrounds="
201 jue-peek.jpg
202 medusa.jpg
203 bsg-supper.jpg
204 rayne.jpg
205 hypatia.jpg
206 noodly.jpg
207 lovelace.jpg"
208 if [ "$xstuff" ]; then
209 echo "Installing backgrounds..."
210 for b in $backgrounds; do
211 for e in enlightenment e16; do
212 dir=$HOME$sub/.$e/backgrounds
213 t=$dir/$b
214 mkdir -p $dir
215 ln -s $here/bg/$b $t.new
216 mv $t.new $t
217 done
218 echo " $b"
219 done
220 echo " all done."
221 fi
222
223 ###--------------------------------------------------------------------------
224 ### Install useful scripts included in this package.
225
226 scripts="
227 mdw-editor
228 mdw-pager
229 mdw-conf
230 mdw-build
231 emacsclient-hack
232 movemail-hack
233 sendmail-hack
234 aspell-hack
235 emerge-hack
236 lesspipe.sh
237 start-ssh-agent
238 svnwrap
239 hyperspec"
240 [ "$xstuff" ] && scripts="$scripts
241 xinitcmd
242 un-backslashify-selection
243 lock-screen
244 xshutdown"
245 echo "Installing scripts..."
246 mkdir -p $HOME$sub/bin
247 for s in $scripts; do
248 ft=$HOME$sub/bin/$s
249 ln -s $here/bin/$s $ft.new
250 mv $ft.new $ft
251 echo " $s"
252 done
253 echo " all done."
254
255 hacks="
256 ssh:ssh"
257 echo "Installing hacks..."
258 for h in $hacks; do
259 d=${h%%:*} h=${h#*:}
260 ft=$HOME$sub/bin/hacks/$d
261 mkdir -p $ft
262 ln -s $here/hacks/$h $ft/$h.new
263 mv $ft/$h.new $ft/$h
264 echo " $d:$h"
265 done
266 echo " all done."
267
268 ###--------------------------------------------------------------------------
269 ### Set up the Emacs config.
270
271 $echon "Finding a suitable emacs:$echoc"
272 emacs=no
273 for i in emacs22 emacs23 emacs21 emacs; do
274 if type -p >/dev/null $i; then
275 emacs=$i
276 break
277 fi
278 done
279 if [ $emacs = no ]; then
280 echo " failed."
281 emacs=:
282 else
283 echo " $emacs."
284 fi
285
286 echo "Installing Emacs packages..."
287 emacspkg="
288 make-regexp
289 ew-hols
290 mdw-gnus-patch
291 git git-blame vc-git stgit
292 quilt"
293 for elib in $emacspkg; do
294 $echon " $elib:$echoc"
295 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
296 (progn
297 (setq load-path (nconc load-path (list "~/lib/emacs")))
298 (kill-emacs (condition-case nil
299 (progn (load-library "'"$elib"'") 0)
300 (error 1))))'; then
301 echo " already installed."
302 else
303 if [ -f el/$elib.el ]; then
304 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
305 else
306 $echon " downloading$echoc"
307 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
308 fi
309 $echon " compiling$echoc"
310 (cd $HOME$sub/lib/emacs;
311 $emacs >/dev/null 2>&1 --no-site-file --batch \
312 --eval '(byte-compile-file "'"$elib.el"'")')
313 echo " done."
314 fi
315 done
316 echo " all done."
317
318 $echon "Setting up Emacs configuration:$echoc"
319 $echon " linking$echoc"
320 for f in dot-emacs.el Makefile; do
321 set -- $(echo $link | tr : ' ')
322 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
323 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
324 done
325 $echon " compiling$echoc"
326 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
327 echo " done."
328
329 ###----- That's all, folks --------------------------------------------------